# coding: utf-8

# flake8: noqa

"""
    Tickforge API

    An API to interact with Uptick Internal Resources

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.1.1"

# import apis into sdk package
from tickforge_client.api.auth_api import AuthApi
from tickforge_client.api.db_api import DbApi
from tickforge_client.api.default_api import DefaultApi
from tickforge_client.api.git_api import GitApi
from tickforge_client.api.github_api import GithubApi
from tickforge_client.api.jobs_api import JobsApi
from tickforge_client.api.redirects_api import RedirectsApi
from tickforge_client.api.slack_api import SlackApi
from tickforge_client.api.workspaces_api import WorkspacesApi

# import ApiClient
from tickforge_client.api_response import ApiResponse
from tickforge_client.api_client import ApiClient
from tickforge_client.configuration import Configuration
from tickforge_client.exceptions import OpenApiException
from tickforge_client.exceptions import ApiTypeError
from tickforge_client.exceptions import ApiValueError
from tickforge_client.exceptions import ApiKeyError
from tickforge_client.exceptions import ApiAttributeError
from tickforge_client.exceptions import ApiException

# import models into sdk package
from tickforge_client.models.author_name import AuthorName
from tickforge_client.models.backup import Backup
from tickforge_client.models.base_user import BaseUser
from tickforge_client.models.batch_id import BatchId
from tickforge_client.models.body_bump_app_api_workspaces_app_name_bump_post import BodyBumpAppApiWorkspacesAppNameBumpPost
from tickforge_client.models.body_qadeploy_api_workspaces_qadeploy_post import BodyQadeployApiWorkspacesQadeployPost
from tickforge_client.models.body_qadestroy_api_workspaces_qadestroy_post import BodyQadestroyApiWorkspacesQadestroyPost
from tickforge_client.models.cluster import Cluster
from tickforge_client.models.copy_db_payload import CopyDBPayload
from tickforge_client.models.create_backup_response import CreateBackupResponse
from tickforge_client.models.create_workspace_payload import CreateWorkspacePayload
from tickforge_client.models.http_validation_error import HTTPValidationError
from tickforge_client.models.job import Job
from tickforge_client.models.job_status import JobStatus
from tickforge_client.models.server_timezone import ServerTimezone
from tickforge_client.models.server_type import ServerType
from tickforge_client.models.token_response import TokenResponse
from tickforge_client.models.validation_error import ValidationError
from tickforge_client.models.validation_error_loc_inner import ValidationErrorLocInner
from tickforge_client.models.versions_config import VersionsConfig
from tickforge_client.models.workspace import Workspace
from tickforge_client.models.workspace_cluster import WorkspaceCluster
from tickforge_client.models.x_hub_signature256 import XHubSignature256


def get_sts_url() -> str:
    import boto3
    import botocore
    sts_client = boto3.client("sts")
    url = botocore.signers.generate_presigned_url(sts_client, "get_caller_identity", HttpMethod="GET")
    assert isinstance(url, str)
    return url


def get_access_token(configuration=None) -> str:
    with ApiClient(configuration) as api_client:
        return AuthApi(api_client).login_for_access_token_api_auth_token_post(username=get_sts_url()).access_token


def set_default_config() -> None:
    access_token = get_access_token()
    default_api_client = ApiClient()
    default_api_client.set_default_header("Authorization", f"Bearer {access_token}")
    ApiClient.set_default(default_api_client)
