# coding: utf-8

"""
    Tickforge API

    An API to interact with Uptick Internal Resources

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist, constr
from tickforge_client.models.server_timezone import ServerTimezone
from tickforge_client.models.server_type import ServerType

class CreateWorkspacePayload(BaseModel):
    """
    CreateWorkspacePayload
    """
    name: constr(strict=True, max_length=30, min_length=3) = Field(...)
    customer: constr(strict=True, max_length=30, min_length=3) = Field(...)
    timezone: ServerTimezone = Field(...)
    server_type: ServerType = Field(...)
    extra_tags: Optional[conlist(StrictStr)] = None
    __properties = ["name", "customer", "timezone", "server_type", "extra_tags"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateWorkspacePayload:
        """Create an instance of CreateWorkspacePayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateWorkspacePayload:
        """Create an instance of CreateWorkspacePayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateWorkspacePayload.parse_obj(obj)

        _obj = CreateWorkspacePayload.parse_obj({
            "name": obj.get("name"),
            "customer": obj.get("customer"),
            "timezone": obj.get("timezone"),
            "server_type": obj.get("server_type"),
            "extra_tags": obj.get("extra_tags")
        })
        return _obj


